#include <stdio.h>
#include <time.h>

// maximalni pocet polozek
#define ITEMS 100

// maximalni pocet instanci uloh
#define MAX_INSTANCES 200

// zadani problemu
int id, items, m;
int item_weight[ITEMS];
int item_cost[ITEMS];

// posledni nalezene reseni
char solution[ITEMS];

// nejlepsi nalezena cena
int best_cost;

// soubory ke cteni a k zapisu
FILE *fin, *fout;

// pocitam si pocet spocitanych instanci
int instances;

// cas zacatku a konce pocitani
time_t start, stop;

// otevri soubory pro cteni zadani a pro zapis reseni
int g_open(char *in, char *out) {
    if((fin = fopen(in, "r")) == NULL) return 0;
    if((fout = fopen(out, "w")) == NULL) return 0;
    instances = 0;
    return 1;
}

// uzavri soubory
void g_close() {
    fclose(fin);
    fclose(fout);
}

// cti dalsi vstup
int g_read() {
    if(feof(fin)) return 0;
    fscanf(fin, "%i %i %i ", &id, &items, &m);
    int i;
    for(i=0; i<items; i++) {
        fscanf(fin, "%i %i", &item_weight[i], &item_cost[i]);
        solution[i]=0;
    }
    best_cost=0;
    instances++;
    return 1;
}

// zapis vysledek
int g_write() {
    fprintf(fout, "%i %i %i", id, items, best_cost);
    int i;
    for(i=0; i<items; i++) fprintf(fout, " %i", solution[i]);
    fprintf(fout, "\n");
}

// nastartuj stopky
void g_start_time() {
    time(&start);
}

// zastav stopky
void g_stop_time() {
    time(&stop);
}

// vrat prumerny cas v sekundach na jednu instanci problemu
double g_time() {
    return difftime(stop, start) / instances;
}

// vrat celkovy cas
double g_time_total() {
    return difftime(stop, start);
}
